#include "testlib.h"

using namespace std;

int main(int argc, char **argv) {
  __testlib_ensuresPreconditions();

  testlibMode = _validator;
  __testlib_set_binary(stdin);
  inf.init(argv[1], _input);
  inf.strict = false;

  int n = inf.readInt(1, 200000, "n");
  int m = inf.readInt(1, 200000, "m");
  inf.readEoln();
  for (int i = 0; i < m; i++) {
    inf.readInt(1, n, "a");
    int v = inf.readInt(-1000000, 1000000, "v");
    if (v == 0) {
      quitf(_fail, "v is 0 for conductor %d (1-based)", i + 1);
    }
    inf.readEoln();
  }
  inf.readEof();
  return 0;
}
